package com.crossover.techtrial.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import com.crossover.techtrial.model.HourlyElectricity;
import com.crossover.techtrial.model.Panel;
import com.crossover.techtrial.repository.HourlyElectricityRepository;

/**
 * HourlyElectricityServiceImpl will handle electricity generated by a Panel.
 *
 * @author Crossover
 *
 */

@Service
public class HourlyElectricityServiceImpl implements HourlyElectricityService
{
    @Autowired
    private HourlyElectricityRepository hourlyElectricityRepository;

    @Autowired
    private PanelService                panelService;

    public HourlyElectricity save(HourlyElectricity hourlyElectricity, String panelSerial)
    {

        Panel panel = panelService.findBySerial(panelSerial);

        hourlyElectricity.setPanel(panel);

        return hourlyElectricityRepository.save(hourlyElectricity);
    }

    public Page<HourlyElectricity> getAllHourlyElectricityByPanelId(Long panelId, Pageable pageable)
    {
        return hourlyElectricityRepository.findAllByPanelIdOrderByReadingAtDesc(panelId, pageable);
    }

    @Override
    public List<HourlyElectricity> findByPanel(Long panelId)
    {
        return hourlyElectricityRepository.findOneByPanelId(panelId);
    }

}
